## debian-cd 2.2.25

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for debian-cd
#
# Copyright 1999 Raphal Hertzog <hertzog@debian.org>
# See the README file for the license

# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef SIZELIMIT
SIZELIMIT=$(shell echo -n $$[ 610 * 1024 * 1024 ])
endif
ifndef TASK
TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
endif
ifndef CAPCODENAME
CAPCODENAME:=$(shell perl -e "print ucfirst("$(CODENAME)")")
endif
ifndef BINDISKINFO
export BINDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num ($$DATE)"
endif
ifndef SRCDISKINFO
export SRCDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num ($$DATE)"
endif
# ND=No-Date versions for README
ifndef BINDISKINFOND
export BINDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num"
endif
ifndef SRCDISKINFOND
export SRCDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num"
endif
ifndef BINVOLID
ifeq ($(ARCH),powerpc)
BINVOLID="Debian $(DEBVERSION) ppc Bin-$$num"
else
BINVOLID="Debian $(DEBVERSION) $(ARCH) Bin-$$num"
endif
endif
ifndef SRCVOLID
SRCVOLID="Debian $(DEBVERSION) Src-$$num"
endif
ifndef MKISOFS
export MKISOFS=mkisofs
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r
#For symlink farmers
#MKISOFS_OPTS=-r -F .
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifneq "$(wildcard $(MIRROR)/dists/$(DI_CODENAME)/main/disks-$(ARCH))" ""
ifndef BOOTDISKS
export BOOTDISKS=$(MIRROR)/dists/$(DI_CODENAME)/main/disks-$(ARCH)
endif
endif
ifndef DOJIGDO
export DOJIGDO=0
endif

# Netinst/businesscard CD have different udeb_include and udeb_exclude files
ifndef UDEB_INCLUDE
ifeq ($(INSTALLER_CD),1)
UDEB_INCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/$(ARCH)_businesscard_udeb_include
endif
ifeq ($(INSTALLER_CD),2)
UDEB_INCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/$(ARCH)_netinst_udeb_include
endif
endif
ifndef UDEB_INCLUDE
UDEB_INCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/$(ARCH)_udeb_include
endif
ifndef UDEB_EXCLUDE
ifeq ($(INSTALLER_CD),1)
UDEB_EXCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/businesscard_udeb_exclude
endif
ifeq ($(INSTALLER_CD),2)
UDEB_EXCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/netinst_udeb_exclude
endif
endif
ifndef UDEB_EXCLUDE
UDEB_EXCLUDE=$(BASEDIR)/data/$(DI_CODENAME)/udeb_exclude
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
list2cds=$(BASEDIR)/tools/list2cds
cds2src=$(BASEDIR)/tools/cds2src
master2tasks=$(BASEDIR)/tools/master2tasks
mirrorcheck=$(BASEDIR)/tools/mirror_check
add_packages=$(BASEDIR)/tools/add_packages
add_dirs=$(BASEDIR)/tools/add_dirs
add_bin_doc=$(BASEDIR)/tools/add-bin-doc
scanpackages=$(BASEDIR)/tools/scanpackages
scansources=$(BASEDIR)/tools/scansources
add_files=$(BASEDIR)/tools/add_files
set_mkisofs_opts=$(BASEDIR)/tools/set_mkisofs_opts
strip_nonus_bin=$(BASEDIR)/tools/strip-nonUS-bin
add_secured=$(BASEDIR)/tools/add_secured
md5sum=md5sum
fastsums=$(BASEDIR)/tools/fast_sums
jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
grab_md5=$(BASEDIR)/tools/grab_md5
dedicated-src=$(BASEDIR)/tools/dedicated_source
make_image=$(BASEDIR)/tools/make_image
add_debs=$(BASEDIR)/tools/add_debs
add_source_packages=$(BASEDIR)/tools/add_source_packages

BDIR=$(TDIR)/$(CODENAME)-$(ARCH)
ADIR=$(APTTMP)/$(CODENAME)-$(ARCH)
SDIR=$(TDIR)/$(CODENAME)-src

FIRSTDISKS=CD1 
ifdef FORCENONUSONCD1
FIRSTDISKS=CD1 CD1_NONUS
forcenonusoncd1=1
else
forcenonusoncd1=0
endif

# Ensure that debootstrap is in the path.
PATH:=$(PATH):/usr/sbin

## DEBUG STUFF ##

PrintVars:
	@num=1; \
	DATE=`date +%Y%m%d` ; \
	echo BINDISKINFO: ; \
        echo $(BINDISKINFO) ; \
	echo SRCDISKINFO: ; \
        echo $(SRCDISKINFO) ; \
	echo BINDISKINFOND: ; \
        echo $(BINDISKINFOND) ; \
	echo SRCDISKINFOND: ; \
        echo $(SRCDISKINFOND) ; \
	echo BINVOLID: ; \
        echo $(BINVOLID) ; \
	echo SRCVOLID: ; \
        echo $(SRCVOLID) ; \

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

## CHECKS ##

# Basic checks in order to avoid problems
ok:
ifndef TDIR
	@echo TDIR undefined -- set up CONF.sh; false
endif
ifndef BASEDIR
	@echo BASEDIR undefined -- set up CONF.sh; false
endif
ifndef MIRROR
	@echo MIRROR undefined -- set up CONF.sh; false
endif
ifndef ARCH
	@echo ARCH undefined -- set up CONF.sh; false
endif
ifndef CODENAME
	@echo CODENAME undefined -- set up CONF.sh; false
endif
ifndef OUT
	@echo OUT undefined -- set up CONF.sh; false
endif
ifdef NONFREE
ifdef EXTRANONFREE
	@echo Never use NONFREE and EXTRANONFREE at the same time; false
endif
endif
ifdef FORCENONUSONCD1
ifndef NONUS
	@echo If we have FORCENONUSONCD1 set, we must also have NONUS set; false
endif
endif

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(OUT) $(TDIR) $(BDIR) $(SDIR) $(ADIR) unstable-map
$(OUT):
	$(Q)mkdir -p $(OUT)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(SDIR):
	$(Q)mkdir -p $(SDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
	$(Q)mkdir -p $(ADIR)/apt-ftparchive-db
# Make sure unstable/sid points to testing/etch, as there is no build
# rule for unstable/sid.
unstable-map:
	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
		ln -s etch $(BASEDIR)/data/sid ; \
	fi
	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
		ln -s etch $(BASEDIR)/tools/boot/sid ; \
	fi

## CLEANINGS ##

# CLeans the current arch tree (but not packages selection info)
clean: ok bin-clean src-clean
bin-clean:
	$(Q)rm -rf $(BDIR)/CD[1234567890]*
	$(Q)rm -rf $(BDIR)/*_NONUS
	$(Q)rm -f $(BDIR)/*.filelist*
	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/bootable-stamp \
	         $(BDIR)/upgrade-stamp $(BDIR)/secured-stamp $(BDIR)/md5-check
src-clean:
	$(Q)rm -rf $(SDIR)/CD[1234567890]*
	$(Q)rm -rf $(SDIR)/*_NONUS
	$(Q)rm -rf $(SDIR)/sources-stamp $(SDIR)/secured-stamp $(SDIR)/md5-check

# Completely cleans the current arch tree
realclean: distclean
distclean: ok bin-distclean src-distclean
bin-distclean:
	$(Q)echo "Cleaning the binary build directory"
	$(Q)rm -rf $(BDIR)
	$(Q)rm -rf $(ADIR)
src-distclean:
	$(Q)echo "Cleaning the source build directory"
	$(Q)rm -rf $(SDIR)

## STATUS and APT ##

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)if [ "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" ];then \
		:> $(ADIR)/status ; \
	else \
		zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$(ARCH)/Packages.gz | \
		perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; \
	               print if (/^Priority: (required|important|standard)/m or \
		       /^Section: base/m);' \
		> $(ADIR)/status ; \
	fi
	# Updating the apt database
	$(Q)$(apt) update
	#
	# Checking the consistence of the standard system
	# If this does fail, then launch make correctstatus
	#
	$(Q)$(apt) check || $(MAKE) correctstatus

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
	# You may need to launch correctstatus more than one time
	# in order to correct all dependencies
	#
	# Removing packages from the system :
	$(Q)set -e; \
	for i in `$(apt) deselected -f install`; do \
		echo $$i; \
		perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
		$(ADIR)/status; \
	done
	#
	# Adding packages to the system :
	$(Q)set -e; \
	for i in `$(apt) selected -f install`; do \
	  echo $$i; \
	  $(apt) cache dumpavail | perl -000 -ne \
	      "s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
	       print if /^Package: \Q$$i\E\s*\$$/m;" \
	       >> $(ADIR)/status; \
	done
	#
	# Showing the output of apt-get check :
	$(Q)$(apt) check

apt-update: status
	@echo "Apt-get is updating his files ..."
	$(Q)$(apt) update


## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/rawlist-exclude
	$(Q)-rm $(BDIR)/list
	$(Q)-rm $(BDIR)/list.exclude

# Generates the list of packages/files to put on each CD
list: bin-list src-list

# Generate the listing of binary packages
bin-list: ok apt-update genlist $(BDIR)/1.packages
$(BDIR)/1.packages:
	@echo "Dispatching the packages on all the CDs ..."
	$(Q)$(list2cds) $(BDIR)/list $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(BDIR)/*.packages; do \
	    newfile=$${file%%.packages}_NONUS.packages; \
	    cp $$file $$newfile; \
	    $(strip_nonus_bin) $$file $$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US packages: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the listing for sources CDs corresponding to the packages included
# in the binary set
src-list: bin-list $(SDIR)/1.sources
$(SDIR)/1.sources:
	@echo "Dispatching the sources on all the CDs ..."
	$(Q)$(cds2src) $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(SDIR)/*.sources; do \
	    newfile=$${file%%.sources}_NONUS.sources; \
	    cp $$file $$newfile; \
	    grep -v non-US $$file >$$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US sources: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list $(BDIR)/list.exclude
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list


$(BDIR)/list.exclude: $(BDIR)/rawlist-exclude
	@echo "Generating the complete list of packages to be removed ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist-exclude \
		  > $(BDIR)/list.exclude

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
# Dirty workaround for saving space, we add some hints to break ties.
# This is just a temporal solution, list2cds should be a little bit less
# silly so that this is not needed. For more info have a look at
# http://lists.debian.org/debian-cd/2004/debian-cd-200404/msg00093.html
ifneq ($(INSTALLER_CD),1)
ifeq ($(INSTALLER_CD),2)
	/bin/echo -e "mawk\nunifont\npptp-linux" >>$(BDIR)/rawlist
else
	/bin/echo -e "mawk\nexim4-daemon-light\nunifont\npptp-linux" >>$(BDIR)/rawlist
endif
endif # INSTALLER_CD 1
ifdef FORCENONUSONCD1
	$(Q)$(apt) cache dumpavail | \
		grep-dctrl -FSection -n -sPackage -e '^(non-US|non-us)' - | \
		sort | uniq > $(BDIR)/Debian_$(CODENAME)_nonUS
endif
	$(Q)if [ _$(INSTALLER_CD) != _1 ]; then \
		mkdir -p $(TDIR); \
		debootstrap --arch $(ARCH) --print-debs $(CODENAME) $(TDIR)/debootstrap.tmp file:$(MIRROR) \
		| tr ' ' '\n' >>$(BDIR)/rawlist; \
		rm -rf $(TDIR)/debootstrap.tmp; \
	fi
	$(Q)perl -npe 's/\@ARCH\@/$(ARCH)/g' $(TASK) | \
	 cpp -nostdinc -nostdinc++ -P -undef -D ARCH=$(ARCH) -D ARCH_$(subst -,_,$(ARCH)) \
	     -U $(ARCH) -U i386 -U linux -U unix \
	     -DFORCENONUSONCD1=$(forcenonusoncd1) \
	     -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist

# Build the raw list (cpp output) with doubles and spaces for excluded packages
$(BDIR)/rawlist-exclude:
	$(Q)if [ -n "$(EXCLUDE)" ]; then \
	 	perl -npe 's/\@ARCH\@/$(ARCH)/g' $(EXCLUDE) | \
			cpp -nostdinc -nostdinc++ -P -undef -D ARCH=$(ARCH) -D ARCH_$(subst -,_,$(ARCH)) \
				-U $(ARCH) -U i386 -U linux -U unix \
	     			-DFORCENONUSONCD1=$(forcenonusoncd1) \
	     			-I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist-exclude; \
	else \
		echo > $(BDIR)/rawlist-exclude; \
	fi

## DIRECTORIES && PACKAGES && INFOS ##

=== debian/changelog ===
debian-cd (2.2.25) unstable; urgency=low

  [ Joey Hess ]
  * Remove net-drivers access floppy from full CD images.

  [ Frans Pop ]
  * Consistently change location for installation guide to /doc/manual
    on the CD.
  * Update author (and timestamp) in README.
  * Colin Watson has taken over daily d-i builds for PowerPC.

  [ Steve McIntyre ]
  * Fix to tools/grab_md5: when building the md5-list, DO NOT use the
    "current" symlink in the d-i directories - that causes jigdo problems
    later on. Use the real dirs (as dated) instead.

  [ Frans Pop ]
  * Remove exclusion of openbsd-inetd for Etch as it is now the prefered
    dependency from netbase. For some reason debootstrap requires both inetd
    packages, so don't exclude netkit-inetd.
    Makes full/netinst images have base_installable again.
  * Thiemo Seufer has resumed building images for mips.

  [ Colin Watson ]
  * Only tell mkisofs to use the prep initrd if it's available (which it
    currently isn't for 2.6.16).

  [ Steve McIntyre ]
  * Fix to tools/grab_md5: reset the file and dir name after each source
    package is finished with.
  * Add extra debug in tools/boot/etch/boot-i386

  [ Joey Hess ]
  * ths has taken over mipsel builds
  * Add sudo to generate_di+k_list, it's needed for installs w/o a root user.
  * Add support to boot/etch/boot-i386 for adding gtk images. If the
    isolinux files include .with26+gtk, include gtk initrd along with the
    2.4 kernel. If .withgtk, include gtk initrd along with the default
    (presumably 2.6) kernel.
  * i386 has stopped building because the el-torito boot images were turned
    off (due to size issues). Fix this by not failing if the el-torito images
    arn't there.
  * d-i doesn't include bast images anymore, drop from boot-arm.
  * Update task.list adding more language tasks.
  * Update task-essential-etch build recipe to exclude the kde-desktop
    task since it won't fit on the CD.
  * Move kde-desktop to end of task.list for same reason.
  * Update task-full-etch to current tasksel.

  [ Steve McIntyre ]
  * Add better GNU/kFreeBSD support in setting ARCH in CONF.sh.
    Closes: #327470

  [ Joey Hess ]
  * Applied patch from smarenka to add 2.6 kernels for m68k, also 2.4 kernels
    for appropriate m68k subarches, and also emile, amiboot, atari-bootstrap,
    and initramfs-tools for m68k.

  [ Steve McIntyre ]
  * Add extra arm kernels and more utilities into the task lists.
    Closes: #373225

  [ Joey Hess ]
  * Correct url to the amd64 dailys.
  * Add gtk initrd to amd64 images if available.
  * Add autorun file to amd64 images if there's a README.html, same as for
    i386.
  * Add pcmciautils-udeb to udeb_include lists; something needs to pull it
    in and like pcmcia-cs-udeb its priority won't.

  [ Frans Pop ]
  * Wouter Verhelst has taken over daily d-i builds for powerpc.
  * AMD64 d-i images are now available from people.d.o.
  * Add cryptsetup to first CD; needed for installations using encrypted
    partitions.

  [ Joey Hess ]
  * Add 686 kernels, since the netinst CD is much larger and can now easily
    fit them and this makes the CD much more attractive for many users.

  [ Frans Pop ]
  * Drop 2.4 support for sparc64; switch from 2.4 to 2.6 for sparc32.
  * Exclude 2.4 kernel udebs for sparc and s/390 (s/390 has switched to 2.6).
  * Include only 2.6 kernel images for sparc.
  * Update to libdevmapper1.02.
  * No need to include yaird for m68k.
  * Drop initrd-tools for ia64, powerpc and sparc.
  * Include initramfs-tools instead of yaird for ia64 and sparc.
  * No initramfs generator needed for mips, mipsel and m68k.

  [ Steve McIntyre ]
  * Switch from 2.4 to 2.6 kernels for arm, mips and mipsel.
  * Switch from yaird over to initramfs-tools for arm.
  * Much simplified generate_di+k_list - mips and mipsel don't need script
    fragments any more.
  * Added elilo for i386.

  [ Joey Hess ]
  * Update task-essential-etch.
  * Update task.list to include all the new language tasks.
  * Update task-full-etch.

  [ Steve McIntyre ]
  * Mips has dropped r5k-ip22 kernels and gained r5k-ip32. And r5k-ip32
    doesn't have CD boot support yet, so don't attempt to use the cdrom
    boot image.

  [ Frans Pop ]
  * There are no "tape" images with 2.6.16 for S/390.
  * Exclude floppy and el-torito images for i386 as they are not being built.
  * Update exclude-udebs lists.
  * Exclude 2.4.27 kernel packages from CD1 for sparc and s/390.
  * Exclude 2.6.15 kernel header and image packages from CD1.
  * Exclude 2.6.16 xen and vserver kernel  packages from CD1.
  * Update generate_di+k_list to include libsysfs2.
  * Update popularity contest data for etch.
  * Update generate_di+k_list to include libdiscover1.

  [ Petter Reinholdtsen ]
  * Add more features to get_diskusage.pl, making it easier to track
    dependencies and rejected packages.
  * Correct splash screen generation for sarge and etch, making sure the
    correct background colour (black) is selected.

  [ Steve McIntyre ]
  * Try to fix the "unofficial development version" bug on official CDs.

  [ Joey Hess ]
  * Include libc6-i686 in generate_di+k_list, base-installer will
    soon begin installing this onto machines that can use it.
    (To regain some space, libc6-amd64 will soon stop being standard priority,
    and drop off.)
  * On sparc, include libc6-sparcv9 and libc6-sparcv9b, which base-installer
    will also pull in.

  [ Colin Watson ]
  * Cope with cdrom64 -> cdrom renaming for powerpc64 subarchitecture.

  [ Sven Luther ]
  * [powerpc] Added a rescue option to yaboot.conf as well as the pegasos boot
    script.

  [ Colin Watson ]
  * Remove obsolete devfs=mount,dall and init=/linuxrc options from
    yaboot.conf and pegasos boot script.
  * Remove init=/linuxrc from hppa.

  [ Otavio Salvador ]
  * Applied patches that are being in use at O.S. Systems and that are
    useful to others:
    - allow to use different name for final iso image;


=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 4)
Build-Depends-Indep: tofrodos | sysutils
Standards-Version: 3.6.1.0

Package: debian-cd
Architecture: all
Depends: perl, cpp, libdigest-md5-perl, tofrodos | sysutils, apt (>= 0.3.11.1), make, mkisofs | mkhybrid, lynx, grep-dctrl, apt-utils (>= 0.5.4), debootstrap, bc
Recommends: hfsutils, debianutils (>= 1.6), jigdo-file (>= 0.7.0)
Suggests: palo (>= 0.94), binutils-multiarch, netpbm, syslinux
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

## debian-cd 3.0.2

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for debian-cd
#
# Copyright 1999 Rapha?l Hertzog <hertzog@debian.org>
# See the README file for the license
#
# Significantly modified 2005-2006 Steve McIntyre <93sam@debian.org>
# for multi-arch and mixed bin/src discs
#
# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef SIZELIMIT
SIZELIMIT=2000000000000
endif
ifndef TASK
TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
endif
ifndef MKISOFS
export MKISOFS=mkisofs
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r
#For symlink farmers
#MKISOFS_OPTS=-r -F .
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifndef DOJIGDO
export DOJIGDO=0
endif

export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
ifeq ($(ARCHES),source)
	export SOURCEONLY=yes
endif
ifeq ($(shell echo $(ARCHES) | sed 's/.*source.*/1/'),1)
	export INC_SOURCE=yes
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
list2cds=$(BASEDIR)/tools/list2cds
md5sum=md5sum
jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
grab_md5=$(BASEDIR)/tools/grab_md5
make_image=$(BASEDIR)/tools/make_image
merge_package_lists=$(BASEDIR)/tools/merge_package_lists
update_popcon=$(BASEDIR)/tools/update_popcon
update_tasks=$(BASEDIR)/tools/update_tasks

BDIR=$(TDIR)/$(CODENAME)
ADIR=$(APTTMP)
DB_DIR=$(BDIR)/debootstrap

export PATH := $(DB_DIR)/usr/sbin:$(PATH)

LATEST_DB := $(shell ls -1tr $(MIRROR)/pool/main/d/debootstrap/debootstrap*all.deb | tail -1)

## DEBUG STUFF ##

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

## CHECKS ##

# Basic checks in order to avoid problems
ok:
ifndef TDIR
	@echo TDIR undefined -- set up CONF.sh; false
endif
ifndef BASEDIR
	@echo BASEDIR undefined -- set up CONF.sh; false
endif
ifndef MIRROR
	@echo MIRROR undefined -- set up CONF.sh; false
endif
ifndef ARCHES
	@echo ARCHES undefined -- set up CONF.sh; false
endif
ifndef CODENAME
	@echo CODENAME undefined -- set up CONF.sh; false
endif
ifndef OUT
	@echo OUT undefined -- set up CONF.sh; false
endif
ifdef NONFREE
ifdef EXTRANONFREE
	@echo Never use NONFREE and EXTRANONFREE at the same time; false
endif
endif
	@if [ $(DISKTYPE) = "NETINST" -o $(DISKTYPE) = "BC" ] ; then \
		if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
			echo "Including source is not supported on a netinst/bc CD"; \
			false; \
		fi; \
	fi

## BOOT & DOC & INSTALL ##

# Basic checks
$(MIRROR)/doc: need-complete-mirror
$(MIRROR)/tools: need-complete-mirror
need-complete-mirror:
	@# Why the hell is this needed ??
	@if [ ! -d $(MIRROR)/doc -o ! -d $(MIRROR)/tools ]; then \
	    echo "You need a Debian mirror with the doc, tools and"; \
	    echo "indices directories ! "; \
	    exit 1; \
	fi

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(BDIR)/DATE $(DB_DIR) unstable-map
$(OUT):
	$(Q)mkdir -p $(OUT)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
$(BDIR)/DATE:
	$(Q)date '+%Y%m%d' > $(BDIR)/DATE
$(DB_DIR): $(LATEST_DB)
	@rm -rf $(DB_DIR)
	@dpkg -x $(LATEST_DB) $(DB_DIR)
# Make sure unstable/sid points to testing/etch, as there is no build
# rule for unstable/sid.
unstable-map:
	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
		ln -s etch $(BASEDIR)/data/sid ; \
	fi
	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
		ln -s etch $(BASEDIR)/tools/boot/sid ; \
	fi

#################
## CLEAN RULES ##
#################

# Cleans the current arch tree (but not packages selection info)
clean: ok dir-clean
dir-clean:
	$(Q)rm -rf $(BDIR)/CD[1234567890]*
	$(Q)rm -f $(BDIR)/*.filelist*
	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/upgrade-stamp $(BDIR)/md5-check

# Completely cleans the current arch tree
realclean: distclean
distclean: ok clean
	$(Q)echo "Cleaning the build directory"
	$(Q)rm -rf $(ADIR)
	$(Q)rm -rf $(TDIR)

####################
## STATUS and APT ##
####################

$(CODENAME)_status: ok init
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		echo "Using the provided status file for $(CODENAME)-$$ARCH ..."; \
		cp $(BASEDIR)/data/$(CODENAME)/status.$$ARCH $(ADIR)/$(CODENAME)-$$ARCH/status 2>/dev/null || $(MAKE) status || $(MAKE) correctstatus ; \
	done

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)for ARCH in $(ARCHES); do \
		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH; \
		if [ $$ARCH = "source" -o "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" ];then \
			:> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		else \
			zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.gz | \
			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		fi; \
	done;
	:> $(ADIR)/status
    # Updating the apt database
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) update; \
	done
    #
    # Checking the consistency of the standard system
    # If this does fail, then launch make correctstatus
    #
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) check || $(MAKE) correctstatus; \
	done

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
    # You may need to launch correctstatus more than one time
    # in order to correct all dependencies
    #
    # Removing packages from the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) deselected -f install`; do \
				echo $$ARCH:$$i; \
				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
				$(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Adding packages to the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) selected -f install`; do \
				echo $$ARCH:$$i; \
				$(apt) cache dumpavail | perl -000 -ne \
				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
				print if /^Package: \Q$$i\E\s*\$$/m;" \
				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Showing the output of apt-get check :
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(apt) check; \
	done

apt-update: status
	$(Q)if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES); do \
			echo "Apt-get is updating its files ..."; \
			ARCH=$$ARCH $(apt) update; \
		done; \
    fi

## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/rawlist-exclude
	$(Q)-rm $(BDIR)/list
	$(Q)-rm $(BDIR)/list.exclude

packagelists: ok apt-update genlist

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
# Dirty workaround for saving space, we add some hints to break ties.
# This is just a temporal solution, list2cds should be a little bit less
# silly so that this is not needed. For more info have a look at
# http://lists.debian.org/debian-cd/2004/debian-cd-200404/msg00093.html
	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ "$(INSTALLER_CD)"x = "1"x ] ; then \
			echo >> $(BDIR)/rawlist; \
	    elif [ "$(INSTALLER_CD)"x = "2"x ] ; then \
			echo -e "mawk\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
	    else \
		    echo -e "mawk\nexim4-daemon-light\nunifont\npptp-linux" >>$(BDIR)/rawlist; \
		fi; \
	fi

	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ _$(INSTALLER_CD) != _1 ]; then \
			for ARCH in $(ARCHES_NOSRC); do \
				debootstrap --arch $$ARCH --print-debs $(CODENAME) $(TDIR)/debootstrap.tmp file:$(MIRROR) 2>/dev/null \
				| tr ' ' '\n' >>$(BDIR)/rawlist; \
				rm -rf $(TDIR)/debootstrap.tmp; \
			done; \
		fi; \
	fi

	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
		ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
	done; \
	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		cat $(TASK) | \
		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
		    -DFORCENONUSONCD1=0 \
		    -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist; \
	fi

    # If we're *only* doing source, then we need to build a list of all the
    # available source packages. Deliberately ignore the tasks too.
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		awk '/^Package:/ {print $$2}' $(ADIR)/$(CODENAME)-source/apt-state/lists/*Sources | \
			sort -u > $(BDIR)/rawlist; \
	fi
#	ls -al $(BDIR)/rawlist

# Build the raw list (cpp output) with doubles and spaces for excluded packages
$(BDIR)/rawlist-exclude:
	$(Q)if [ -n "$(EXCLUDE)" ]; then \
		for ARCH in $(ARCHES); do \
			ARCHDEFS="$$ARCHDEFS -D ARCH_$(subst -,_,$$ARCH)"; \
			ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
		done; \
	 	perl -npe 's/\@ARCH\@/$(ARCH)/g' $(EXCLUDE) | \
			cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS \
			$$ARCHUNDEFS -U i386 -U linux -U unix \
			-DFORCENONUSONCD1=0 \
			-I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist-exclude; \
	else \
		echo > $(BDIR)/rawlist-exclude; \
	fi

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list $(BDIR)/list.exclude
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included in $(BDIR)/list..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list

$(BDIR)/list.exclude: $(BDIR)/rawlist-exclude
	@echo "Generating the complete list of packages to be removed ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist-exclude \
		  > $(BDIR)/list.exclude

## IMAGE BUILDING ##

image-trees: ok genlist
    # Use list2cds to do the dependency sorting
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(list2cds) $(BDIR)/list $(SIZELIMIT); \
	done
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		awk '{printf("source:%s\n",$$0)}' $(BDIR)/list > $(BDIR)/packages; \
	else \
		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
	fi
	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" $(MKISOFS)

# DOJIGDO actions   (for both binaries and source)
#    0    isofile
#    1    isofile + jigdo, cleanup_jigdo
#    2    jigdo, cleanup_jigdo
#
images: ok $(OUT) $(BDIR)/md5-check
	$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DOJIGDO)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"

check-number-given:
	@test -n "$(CD)" || (echo "Give me a CD=<num> parameter !" && false)

# Generate only one image number $(CD)
image: check-number-given images

# Calculate the md5sums for the images (if available), or get from templates
imagesums:
	$(Q)$(BASEDIR)/tools/imagesums $(OUT)

## MISC TARGETS ##

$(BDIR)/md5-check: mirrorcheck	

mirrorcheck: ok
	$(Q)$(grab_md5) $(MIRROR) "$(ARCHES)" $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check
	$(Q)for ARCH in $(ARCHES); do \
		if [ -e $(BASEDIR)/data/$(CODENAME)/$$ARCH/extra-sources ]; then \
			echo "Extra dedicated source added; need to grab source MD5 info too"; \
			$(grab_md5) $(MIRROR) source $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check; \
		fi; \
	done

update-popcon:
	$(update_popcon) tasks/popularity-contest-$(CODENAME)

update-tasks:
	$(update_tasks) $(CODENAME)

# Little trick to simplify things
official_images: ok init packagelists image-trees images

=== debian/changelog ===
debian-cd (3.0.2) unstable; urgency=high

  [ Steve McIntyre ]
  * Remove mention of m68k in data/etc/README.html.in.
  * Other small wording changes and fixes in the README file.
  * Fix up the Debian_etch, Debian_etch-kde and Debian_etch-xfce
    to use debian-installer+kernel-etch rather than -sid. Closes: #416551.
  * Fix up boot-alpha to calculate the size of the ramdisk needed, rather
    than hard-coding to 16384. Also slight refactoring.

  [ Frans Pop ]
  * Add initrd-tools to forcd1 as it is needed for Sarge to Etch upgrades.

  [ Steve McIntyre ]
  * YA "last for etch" upload.

 -- Steve McIntyre <93sam@debian.org>  Wed, 28 Mar 2007 22:57:41 +0100

debian-cd (3.0.1) unstable; urgency=high

  [ Frans Pop ]
  * Remove SRCEXCLUDE which is no longer supported.

  [ Steve McIntyre ]
  * Improve commenting in CONF.sh - make it clear that if you're making
    a netinst, you need to set TASK as well as INSTALLER_CD.

  [ Joey Hess ]
  * Updated tasks for tasksel 2.66.
  * Use the 64 bit autodetection feature of syslinux 3.31-2, if available,
    to default to the 64 bit target in multiarch isos.
  * Updated isolinux.bin to the version from syslinux 3.31-2.
  * Temporarily disable use of 64 bit detection due to syslinx's bug #410729.

  [ Steve McIntyre ]
  * Updates to update-cd:
    + Updates for sarge r5
    + Add support for update DVDs
    + Change parameters used - argument should now be cd or dvd rather than
    + arches to run

  [ Raphael Hertzog ]
  * Don't rely on PATH to find make_disc_trees.pl, start_new_disc, add_files
    and set_mkisofs_opts.
  * Make sure "make mirrorcheck" has been called before "make images".

  [ Steve McIntyre ]
  * Cope with rolling back more than one package in case we go well
    over the disc size
  * Use a multiplier of 1.2 for HFS space - overkill, but it fixes
    the multi-arch DVD overflowing. Also log if we're doing HFS.
  * Tweak where we look for s390 boot files to make the weeklies work again.

  [ Joey Hess ]
  * Updated isolinux.bin to the version from syslinux 3.31-3.
  * Re-enable use of 64 bit detection, fixed now.

  [ Raphael Hertzog ]
  * Fix make_disc_trees.pl to not clash on unexcluded packages which contains
    regex special characters. Closes: #413506

  [ Frans Pop ]
  * forcd1-etch: remove network-console-config (not in Etch).
  * forcd1-etch: add kernel-package and module-assistant.

  [ Steve McIntyre ]
  * Fix path for creating splash image in boot-amd64. Closes: #413850.
  * Add the DEFAULT64 handling to boot-amd64 as well as boot-i386; needed
    in both so that things are setup the same regardless of the order in
    which the boot-$arch scripts are called
  * Fix the extra_image() function in both boot-i386 and boot-amd64 to make
    sure we don't end up overwriting extra images from one arch with those
    from the other. Now the multi-arch netinst should work for the installgui
    target for both arches
  * Check in current working versions of the tasks files.
  * Fix a silly bug in start_new_disc that would break on discs with
    local packages. Thanks to Ronny Aasen for the patch. Closes: #414818
  * Final *final* upload for etch; urgency high to get through the
    freeze.

 -- Steve McIntyre <93sam@debian.org>  Tue, 13 Mar 2007 23:36:44 +0000

debian-cd (3.0.0) unstable; urgency=medium

  * Support now added for multi-arch CDs/DVDs, including mixed
    binary/source discs. Multi-arch discs should be bootable on those
    multiple arches, modulo boot-sector clashes. Extra support added
    in boot-i386 and boot-amd64 to make the 2 main arches happily
    co-exist.

  * Disc sizing is now much more intelligent - sizes are defined
    depending on the disk type chosen at the start, and discs are now
    filled exactly to those sizes while files are added rather than
    the old up-front guessing method. Equally, the metadata on the
    disc (Packages, Packages.gz, Sources, Sources.gz, md5sums.txt) is
    generated as much as possible while this is happening to make the
    sizing code incredibly accurate. Using this method of disc sizing
    means that customising discs should be much easier/safer - either
    add custom contents at the start and debian-cd will fill the
    remainder of the disc, or afterwards roll back the packages on the
    disc and add extras later.

  * Source is now treated as (almost) just another arch, with most of
    the special casing for source hidden internally. If asking for
    source-only discs, they will simply be built using all the
    available sources. If combined with other arches, the sources will
    automatically be chosen to match the binary packages. Meeting GPL
    requirements was never so easy!

  * Removed lots of old cruft to clean up the codebase:
    + non-US support
    + woody support
    + lots of old support scripts that have been made redundant
    + significantly simpler Makefile, much easier to follow
    + old boot-$ARCH.calc files for estimating boot-file sizes are now
      (obviously) obsolete and therefore gone

  Other changes:

  [ Petter Reinholdtsen ]
  * Update tools/boot/*/boot-amd64 to use the correct isolinux
    splash image settings, and to insert $KERNEL_PARAMS correctly into
    isolinux.cfg.  Based on patches already implemented in boot-i386.

  [ Joey Hess ]
  * Remove 2.4 kernels from generate_di+k_list for i386.
  * Remove 2.2 kernel for mac from generate_di+k_list, as it's no longer in
    the archive.
  * Deal with new xfce-desktop task.

  [ Steve McIntyre ]
  * Merge patch from Petter to allow override of the default boot choice
    in syslinux using the ISOLINUX_DEFAULT config option. Closes: #393229

  [ Joey Hess ]
  * Include brltty in generate_di+k_list.
  * Increase alpha hardcoded ramdisk_size to 20 mb, 16 is too small now.

  [ Frans Pop ]
  * Remove boot parameters that are no longer needed after switch to initramfs
    initrds for sparc and hppa.
  * tasks/exclude-etch: clean out obsolete entries.


=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 4)
Build-Depends-Indep: tofrodos | sysutils
Standards-Version: 3.6.1.0
XS-Vcs-Svn: svn://svn.debian.org/debian-cd/trunk

Package: debian-cd
Architecture: all
Depends: perl, cpp, libdigest-md5-perl, tofrodos | sysutils, apt (>= 0.3.11.1), make, mkisofs | genisoimage, lynx, grep-dctrl, bc, libcompress-zlib-perl
Recommends: hfsutils, netpbm, syslinux
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DH_COMPAT=4

build: build-stamp
build-stamp:
	dh_testdir

	#CONFIGURE#
	# Add here commands to compile the package.
	#$(MAKE) 

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp

	# Add here commands to clean up after the build process.
	#-#CLEAN#

	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	cp -r tools tasks data Makefile README README.devel build.sh \
              build_all.sh update-cd debian/debian-cd/usr/share/debian-cd/
	cp debian/CONF.sh debian/debian-cd/etc/debian-cd/conf.sh
	ln -sf /etc/debian-cd/conf.sh \
               debian/debian-cd/usr/share/debian-cd/CONF.sh
	find debian/debian-cd -name '.svn' | xargs -r rm -rf
	find debian/debian-cd/usr/share/debian-cd/tools/boot \
	  \( -name 'boot-*' -o -name 'post-boot-*' \) -a \! -name '*.txt' \
	  -a \! -name '*.calc' |  xargs chmod 0755

	touch install-stamp

# Build architecture-dependent files here.
binary-arch: build install
# We have nothing to do by default.

# Build architecture-independent files here.
binary-indep: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdocs README*
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installinit
	dh_installcron
	dh_installmanpages
#	dh_undocumented
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here
#	dh_makeshlibs
	dh_installdeb
#	dh_perl 
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## debian-cd 3.0.3

=== Makefile ===
--- 
+++ 
@@ -58,11 +58,13 @@
 merge_package_lists=$(BASEDIR)/tools/merge_package_lists
 update_popcon=$(BASEDIR)/tools/update_popcon
 update_tasks=$(BASEDIR)/tools/update_tasks
+grab_source_list=$(BASEDIR)/tools/grab_source_list
 
 BDIR=$(TDIR)/$(CODENAME)
 ADIR=$(APTTMP)
 DB_DIR=$(BDIR)/debootstrap
 
+export DEBOOTSTRAP_DIR := $(DB_DIR)/usr/lib/debootstrap
 export PATH := $(DB_DIR)/usr/sbin:$(PATH)
 
 LATEST_DB := $(shell ls -1tr $(MIRROR)/pool/main/d/debootstrap/debootstrap*all.deb | tail -1)
@@ -137,14 +139,14 @@
 $(DB_DIR): $(LATEST_DB)
 	@rm -rf $(DB_DIR)
 	@dpkg -x $(LATEST_DB) $(DB_DIR)
-# Make sure unstable/sid points to testing/etch, as there is no build
+# Make sure unstable/sid points to testing/lenny, as there is no build
 # rule for unstable/sid.
 unstable-map:
 	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
-		ln -s etch $(BASEDIR)/data/sid ; \
+		ln -s lenny $(BASEDIR)/data/sid ; \
 	fi
 	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
-		ln -s etch $(BASEDIR)/tools/boot/sid ; \
+		ln -s lenny $(BASEDIR)/tools/boot/sid ; \
 	fi
 
 #################
@@ -350,7 +352,7 @@
 		ARCH=$$ARCH $(list2cds) $(BDIR)/list $(SIZELIMIT); \
 	done
 	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
-		awk '{printf("source:%s\n",$$0)}' $(BDIR)/list > $(BDIR)/packages; \
+		$(grab_source_list) $(BDIR) $(ADIR) $(BDIR)/list $(BDIR)/packages; \
 	else \
 		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
 	fi

=== debian/changelog ===
debian-cd (3.0.3) unstable; urgency=low

  [ Steve McIntyre ]
  * In start_new_disc, cope with $DEBVERSION containing spaces.
  * Only put the release notes and installation guide on disc#1.
  * In list2cds, don't add udebs in the final COMPLETE run -
    they're no use there.
  * Add some munging on the Release files if we're not building
    for "testing". Used in the etch release, and I'll back it out shortly.
  * Copied etch files to lenny ready for the new testing work.

  [ Frans Pop ]
  * Clean up: remove files for potato and woody releases.

  [ Steve McIntyre ]
  * Removed m68k from the list of arches in generate_di+k_list and
    generate_di_list to reduce warnings.
  * Updated comments in update-cd; potato was a while ago!
  * It seems the changes for 3.0.0 completely broke extranonfree
    support. Re-add it.

  [ Frans Pop ]
  * Dann Frazier has taken over from Jeff Bailey for daily IA64 D-I builds.
  * General update the template for the README file; explain the difference
    between small and full images better. Closes: #418195.

  [ Steve McIntyre ]
  * Re-added DEBOOTSTRAP_DIR definition in the Makefile
  * Don't hack with the Release file unless EARLY_BUILD_HACK=1.
    Closes: #423463

  [ Joey Hess ]
  * Remove pcmcia-cs-udeb from udeb_include; we don't need this udeb with
    modern kernels. (We didn't need it for etch either actually.)

  [ Steve McIntyre ]
  * Fix for multi-arch CDs including source - the extranonfree update
    broke the source output

  [ Frans Pop ]
  * Include both dhcp-client-udeb and dhcp3-client udeb while we're
    transitioning in the installer.
  * Exclude live-installer, simple-cdd, pwgen and nbd udebs as they are
    currently not used in Debian Installer.
  * Remove support for sparc32 as it is no longer supported for Lenny.

  [ Steve McIntyre ]
  * Update unstable-map: in the Makefile - use lenny rather than etch

  [ Petter Reinholdtsen ]
  * Update tools/grab_md5 to use the same variable name (SUITE->CODENAME)
    as the rest of the code, to reduce confusion.

  [ Joey Hess ]
  * Drop old with26 cruft for lenny.
  * Update lenny's isolinux.bin to the one from syslinux 3.51-1
  * Parse isolinux.cfg case-insensatively.
  * Merge boot-i386 and boot-amd64 into boot-x86.

  [ Otavio Salvador ]
  * Fix extranonfree support to be backward compatible with previous
    behaviour (default to false)
  * Create dpkg status file before calling APT

  [ Steve McIntyre ]
  * Fix boot-x86 shell syntax so it runs
  * Further logic fixing in boot-x86: amd64 should now work
  * Temporary fixup for daily lenny sparc builds - use older image locations
    if new ones not available.
  * Remove Build-Dep-Indep on sysutils. Closes: #437497
  * In build.sh, use $DI_CODENAME for installer task files rather than
    $CODENAME - allows for sid builds more easily etc.	
  * Recompress the Packages files separately just before generating
    Release files. Closes: #423835, thanks to fjp for the patch.
  * Check if required base packages might also be supplied by a local
    repository too, not just the main distribution. Closes: #425600
  * Merge update-cd changes across from the version in etch.

 -- Steve McIntyre <93sam@debian.org>  Sat, 01 Sep 2007 23:58:42 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian CD Group <debian-cd@lists.debian.org>
 Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
 Build-Depends: debhelper (>= 4)
-Build-Depends-Indep: tofrodos | sysutils
+Build-Depends-Indep: tofrodos
 Standards-Version: 3.6.1.0
 XS-Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
